{% macro graph_bar(value, min, max, type) %}
{% set width = ((value - min) * 100 / (max - min)) - 50 %}
{% set margin = 50 %}
{% if width < 0 %}
{% set margin = 50 + width %}
{% set width = 50 - margin %}
{% set direction = 'reversed' %}
{% endif %}
<div class="{{ type }} bar {{ direction }}">
  <div class=wrapper style="width: {{ width }}%; margin-left: {{ margin }}%">
    <span>{{ value|_ }}</span>
  </div>
</div>
{% endmacro %}

{% macro graph_row(result, trait) %}
<tr class=maintrait>
  <td class=title>{{ trait|_ }}</td>
  <td class=description>{{ (('1d.' + trait + '.short_description_low'))|_ }}</td>
  <td class=values>
    {{ graph_bar(result.average_rawscores[trait]|round(1), 1, 5, 'rawscore') }}
    {{ graph_bar(result.tscores[trait]|round, 20, 80, 'tscore') }}
    {{ graph_bar(result.percentiles[trait]|round, 1, 99, 'percentile') }}
  </td>
  <td class="description">{{ ('1d.' + trait + '.short_description_high')|_ }}</td>
</tr>
{% endmacro %}

{% macro trait_table_thead() %}
  <thead>
    <tr>
      <th>{{ "Trait/Subtrait"|_ }}</th>
      <th>{{ "Avg. Raw Score"|_ }}</th>
      <th>{{ "% Contribution to the Dynamics of Personality"|_ }}</th>
      <th>{{ "T-Score"|_ }}</th>
      <th>{{ "Percentile Score"|_ }}</th>
    </tr>
  </thead>
{% endmacro %}

{% macro trait_table(result, contributions, sorted_subtraits, trait) %}
  {{ trait_table_row(result, contributions, sorted_subtraits, trait) }}
  {% for subtrait in result.maintrait_questions.get(trait) %}
  {{ trait_table_row(result, contributions, sorted_subtraits, subtrait) }}
  {% endfor %}
{% endmacro %}


{% macro trait_table_row(result, contributions, sorted_subtraits, trait) %}
  <tr class="{% if trait|count == 2 %}maintrait{% endif %} {% if trait in sorted_subtraits[:3] %}low{% elif trait in sorted_subtraits[-3:]%}high{% endif %}">
    <th>{{ trait|_ }}</th>
    <td>{{ result.average_rawscores[trait]|round(2) }}</td>
    <td>{{ contributions[trait]|round(1) }}%</td>
    <td>{{ result.tscores[trait]|round }}</td>
    <td>{{ result.percentiles[trait] }}%</td>
  </tr>
{% endmacro %}

{% macro qualitative_score(result, trait) %}
  {% set delta = (3 - 1) / 3 %}
  {% set rawscore = result.average_rawscores[trait] %}
  {% set index = ((rawscore - 1) / delta)|floor %}
  {% set qualitatives = ['very_low', 'low', 'average_low', 'average_high', 'high', 'very_high'] %}
  <dt>{{ trait|_ }}: {{ qualitatives[index]|_ }}</dt>
  <dd>{{ ('1d.' + trait + '.description')|_ }}</dd>
{% endmacro %}


{% macro graph_2d(result, combo, axis, with_title) %}
<section class=graph_2d>
  {% if with_title %}
  <h3>{{ ('1d.' + axis[0] + '.abbr')|_ }} <small>x</small>
      {{ ('1d.' + axis[1] + '.abbr')|_ }}</h3>
  {% endif %}
  <div class=graphic>
    <ul>
      {# top left #}
      <li><h3 class=title>{{ ('2d.' + combo[0].upper() + combo[1] + '.abbr')|_ }}</h3>
        <span>{{ ('2d.' + combo[0].upper() + combo[1] + '.short_description')|_ }}</span>
      </li>
      {# top right #}
      <li><h3 class=title>{{ ('2d.' + combo[0].upper() + combo[1].upper() + '.abbr')|_ }}</h3>
        <span>{{ ('2d.' + combo[0].upper() + combo[1].upper() + '.short_description')|_ }}</span>
      </li>
      {# bottom left #}
      <li><h3 class=title>{{ ('2d.' + combo[0] + combo[1] + '.abbr')|_ }}</h3>
        <span>{{ ('2d.' + combo[0] + combo[1] + '.short_description')|_ }}</span>
      </li>
      {# bottom right #}
      <li><h3 class=title>{{ ('2d.' + combo[0] + combo[1].upper() + '.abbr')|_ }}</h3>
        <span>{{ ('2d.' + combo[0] + combo[1].upper() + '.short_description')|_ }}</span>
      </li>
    </ul>
    {% set value_x = (result.average_rawscores[axis[1]] - 1) * 25 %}
    {% set value_y = (result.average_rawscores[axis[0]] - 1) * 25 %}
    <div class=value style="top: {{ 100-value_y }}%; left: {{ value_x }}%"></div>
  </div>
</section>
{% endmacro %}


{% macro graph_3d(value, combo, axes_labels, reversed) %}
  <section class="graph-cube {% if reversed %}reversed{% endif %}">
    <div>
      <ul class=values>
        {% set case = casify_3d(combo, ['l', 'l', 'l']) %}
        <li{% if value == case %} class=selected{% endif %}>{{ ('3d.' + case)|_ }}</li>
        {% set case = casify_3d(combo, ['l', 'l', 'h']) %}
        <li{% if value == case %} class=selected{% endif %}>{{ ('3d.' + case)|_ }}</li>
        {% set case = casify_3d(combo, ['l', 'h', 'l']) %}
        <li{% if value == case %} class=selected{% endif %}>{{ ('3d.' + case)|_ }}</li>
        {% set case = casify_3d(combo, ['l', 'h', 'h']) %}
        <li{% if value == case %} class=selected{% endif %}>{{ ('3d.' + case)|_ }}</li>
        {% set case = casify_3d(combo, ['h', 'l', 'l']) %}
        <li{% if value == case %} class=selected{% endif %}>{{ ('3d.' + case)|_ }}</li>
        {% set case = casify_3d(combo, ['h', 'l', 'h']) %}
        <li{% if value == case %} class=selected{% endif %}>{{ ('3d.' + case)|_ }}</li>
        {% set case = casify_3d(combo, ['h', 'h', 'l']) %}
        <li{% if value == case %} class=selected{% endif %}>{{ ('3d.' + case)|_ }}</li>
        {% set case = casify_3d(combo, ['h', 'h', 'h']) %}
        <li{% if value == case %} class=selected{% endif %}>{{ ('3d.' + case)|_ }}</li>
    </ul>

    <ul class=axes>
      <li>{{ axes_labels[0]|_ }}</li>
      <li>{{ axes_labels[1]|_ }}</li>
      <li>{{ axes_labels[2]|_ }}</li>
    </ul>
  </div>
  </section>
{% endmacro %}

{% macro qualitative_1d(result, scores, contributions, sorted_rawscores, trait) %}
  <h2 class=qualitative_name>{{ trait|_ }} — <span>{{ scores[trait]['qualitative']|_ }}</span></h2>

  <table class=qualitative_1d>
    {{ trait_table_thead() }}
    <tbody>
      {{ trait_table(result, contributions, sorted_rawscores, trait) }}
    </tbody>
  </table>

  {{ integration_graph(scores[trait]['integration']) }}

  <p>{{ ('1d.' + trait + '.description_' + scores[trait]['tendency'])|_ }}</p>
{% endmacro %}

{% macro integration_graph(value) %}
  <div class="integration_graph">
    <p>integration: {{ value }}</p>
    {% if value >= 2 * 4/3 %}
        {% set color = "#E77" %}
    {% elif value >= 4/3 %}
        {% set color = "#EE7" %}
    {% else %}
        {% set color = "#7E7" %}
    {% endif %}
    <div class="bar {{ class }}" style="width: {{ 100 * value / 4 }}%; background-color: {{ color }}"></div>
    <div class="min">{{ "High Integration"|_ }}</div>
    <div class="max">{{ "Low Integration"|_ }}</div>
  </div>
{% endmacro %}


{% macro trait_table_extremes(results, subtraits) %}
  <table class=extreme_1d>
    <thead>
      <tr>
        <th>{{ "Trait/Subtrait"|_ }}</th>
        <th>{{ "Avg. Raw Score"|_ }}</th>
        <th>{{ "Description"|_ }}</th>
      </tr>
    </thead>
    <tbody>
      {% for subtrait in subtraits %}
      {% set score = results.average_rawscores[subtrait] | round(2) %}
      {% set direction = 'low' if score < 3 else 'high' %}
      <tr class="{{ direction }}">
        <th>{{ subtrait|_ }}</th>
        <td>{{ score }}</td>
        <td>{{ ('1d.' + subtrait + '.description_' + direction)|_|markdown }}</td>
      </tr>
      {% endfor %}
    </tbody>
  </table>
{% endmacro %}
